/***************************************************************************
               buzzertest.c  -  The Buzzer Debuging tool
                         -------------------
    begin                : So 15 Mai 2005 
    copyright            : (C) 2004 by Frederick Bullik
    email                : Frederick.Bullik@web.de
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h> /*include datei die das Komandozeilen handling vereinfacht*/
#include <time.h>
#include <math.h>
#include <sys/io.h>

#include "SDL.h"

/* Define our booleans */
 #define TRUE  1 
 #define FALSE 0 

/* #ifdef LIBXML_TREE_ENABLED*/

/* screen width, height, and bit depth */
/** \brief Die Bildschirmbreite fuer den Fenstermodus */
#define SCREEN_WIDTH  1024
/** \brief Die Bildschirmhohe fuer den Fenstermodus */
#define SCREEN_HEIGHT 768
/** \brief Farbtiefe des Bildschirmes */
#define SCREEN_BPP    24 

/* make prototype of getopt because of "implicit declaration" */
int getopt(int argc, char * const argv[], const char *optstring);
extern char *optarg;
extern int optind, opterr, optopt;

int port_adr;

int debugmode = FALSE;

/** \brief Hier Raeumen wir nach Programablauf auf.
*
* \param returnCode Der Zurueckzugebende Return Code
* \return Gibt den Uebergebenen Code aus
*/
/* function to release/destroy our resources and restoring the old desktop */
void Quit( int returnCode )
{
	
 /* clean up the window */
    SDL_Quit( );

    /* and exit appropriately */
    exit( returnCode );
}

int get_lp_base(void)
{
 int i, base_adr[3] = {0x3bc, 0x378, 0x278};

 for(i=0; i<3; i++)
 {
 outb_p(0, base_adr[i]);
 if (inb_p(base_adr[i]) == 0)
	return(base_adr[i]);
 }
return(0);
}

void draw_sdl (void)
{
int status;
status = inb(port_adr + 1);
if(status != 239)
{
	if(debugmode == TRUE)
	{
	printf("\033[33m Integer Wert: %i,   Hex Wert: %x \033[m \n", status, status);
	while (status != 239)
			{
				status = inb(port_adr + 1);
			}
	}
	if(status == 207)
	{
	printf("\033[m Der Buzzer ohne Farbe wurde Gedrueckt Integer: %i \n",status); 
	 while (status != 239)
		                         {
						  status = inb(port_adr + 1);
		                         }
	}
	if(status == 175)
	{
	printf("Der \033[32m Gruene \033[m Buzzer wurde Gedrueckt Integer: %i \n",status);
	 while (status != 239)
		                         {
						  status = inb(port_adr + 1);
	                         }
	 }
	if(status == 111)
	{
	printf("Der \033[31m Rote \033[m Buzzer wurde Gedrueckt, Integer: %i \n", status);
	 while (status != 239)
                                       {
				                status = inb(port_adr + 1);	
				       }     
		
	}
}
}


int main( int argc, char **argv )
{
  /** \brief Zählt argc*/
   int option;

   /** \brief Variable der Hauptschleife */
    int done = FALSE;
    /** \brief sammelt Events */
    SDL_Event event;
     
	  
 while (( option = getopt(argc, argv, "hv")) >= 0)
	  switch (option)
	  {
	  case 'h': {
	  printf("Usage: %s [Optionen] \n Optionen: \n -h	 	print this help Text \n",argv[0]);
	  Quit(0);
	  	}
	  break;
		
	  case 'v': debugmode = TRUE;
	  break;
	  }

        printf("\n         \033[36m buzzertest -- The Buzzer Debugging tool \n Copyright (c) 2005 Frederick Bullik <Frederick.Bullik@gmx.de>\n\n This program is free software; you can redistribute it and/or\n modify it under the terms of the GNU General Public License\n as published by the Free Software Foundation; either version 2\n of the License, or (at your option) any later version.\n\n This program is distributed in the hope that it will be useful,\n but WITHOUT ANY WARRANTY; without even the implied warranty of\n MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n GNU General Public License for more details.\n\n You should have received a copy of the GNU General Public License\n along with this program; if not, write to the Free Software \n Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.\033[m \n\n");

printf("=============================================================\n");

    if (iopl(3) != 0)
	{
	printf("\033[33m Hi, here is buzzertest:\033[31m I can't set I/O permissions, Sorry \033[m \n");
	return(1);
	}

    if ((port_adr = get_lp_base()) == 0)
    	{
	  printf("\033[33m buzzertest:\033[31m No parallel port found, Sorry \033[m \n");
	  return(1);
	}
    printf("\033[33m buzzertest: \033[32m Parrallel port found at 0x%x. \033[m \n", port_adr);

        
    /* wait for events */ 
    while ( !done )
	{
	    /* handle the events in the queue */

	    while ( SDL_PollEvent( &event ) )
		{
		    switch( event.type )
			{
						    
			case SDL_KEYDOWN:
			    /* handle key presses */
                          switch (event.key.keysym.sym){
			  
				case SDLK_ESCAPE:
	    			Quit( 0 );
	    			break;
								
				case SDLK_q:
				Quit( 0 );
				break;
										  			  				       
			 	 default:
			 	 break;
			  }
                       break;   
					
		     case SDL_QUIT:
			    /* handle quit requests */
			    done = TRUE;
		    break;
		}
	break;
       	}
  draw_sdl();	
}
 

    /* clean ourselves up and exit */
    Quit( 0 );

    /* Should never get here */
    return( 0 );
}
	
